<!DOCTYPE html>
<html lang="fr">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />

    <!-- Bootstrap CSS -->
    <link
      href="https://stackpath.bootstrapcdn.com/bootswatch/4.3.1/litera/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-D/7uAka7uwterkSxa2LwZR7RJqH2X6jfmhkJ0vFPGUtPyBMF2WMq9S+f9Ik5jJu1"
      crossorigin="anonymous"
    />

    <!-- Font Awesome -->
    <!--
		<link rel="stylesheet" href="fa/css/all.min.css" />
		-->
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free@5.9.0/css/all.min.css"
    />

    <!-- YASGUI stuff -->
    <link
      href="https://cdn.jsdelivr.net/npm/yasgui-yasqe@2.11.22/dist/yasqe.min.css"
      rel="stylesheet"
      type="text/css"
    />
    <link
      href="https://cdn.jsdelivr.net/npm/yasgui-yasr@2.12.19/dist/yasr.min.css"
      rel="stylesheet"
      type="text/css"
    />

    <!-- datepicker -->
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/@chenfengyuan/datepicker@1.0.9/dist/datepicker.min.css"
    />

    <title>SPARnatural - Orlando Data</title>

    <style>
      .yasqe .CodeMirror {
        font-size: 0.8em;
        height: 400px;
      }

      .yasr_header {
        display: none;
      }
    </style>

    <link href="sparnatural.css" rel="stylesheet" />
  </head>
  <body>
    <header>
      <nav class="navbar navbar-expand navbar-dark bg-dark">
        <a class="navbar-brand display-1 mr-auto" href="#"
          >SPARnatural - Orlando Data</a
        >
        <span class="navbar-text" style="margin-right: 100px">
          <a href="?lang=fr">fr</a>&nbsp;|&nbsp;<a href="?lang=en">en</a>
        </span>
      </nav>
    </header>

    <div class="container-fluid" style="margin-top: 1em">
      <div class="row">
        <div class="col-md-7">
          <div id="ui-search"></div>
        </div>
        <div class="col-md-5">
          <div class="row" style="margin-bottom: 0.5em">
            <div class="col-md-12">
              <span style="font-size: 90%">
                Requests are sent to
                <a
                  id="endpoint"
                  href="https://fuseki.lincsproject.ca/cwrc/sparql"
                  >https://fuseki.lincsproject.ca/cwrc/sparql</a
                >
              </span>
            </div>
          </div>
          <div class="row">
            <div class="col-md-12">
              <textarea id="yasqe"></textarea>
            </div>
          </div>
        </div>
      </div>
      <div class="row justify-content-center">
        <div class="col-md-11">
          <div id="yasr"></div>
        </div>
      </div>
    </div>

    <footer id="footer" style="margin-top: 30px; text-align: center">
      <a href="http://blog.sparna.fr" target="_blank">Thomas Francart</a>
      &nbsp;|&nbsp;
      <a href="http://sparna.fr" target="_blank"><img src="sparna.png" /></a>
      &nbsp;|&nbsp;
      <a href="https://github.com/sparna-git/Sparnatural" target="_blank"
        >Voir sur Github</a
      >
      <br />
      <br />
    </footer>

    <a
      href="https://github.com/sparna-git/Sparnatural"
      class="github-corner"
      aria-label="View on GitHub"
      ><svg
        width="100"
        height="100"
        viewBox="0 0 250 250"
        style="
          fill: #fd6c6c;
          color: #fff;
          position: absolute;
          top: 0;
          border: 0;
          right: 0;
        "
        aria-hidden="true"
      >
        <path d="M0,0 L115,115 L130,115 L142,142 L250,250 L250,0 Z"></path>
        <path
          d="M128.3,109.0 C113.8,99.7 119.0,89.6 119.0,89.6 C122.0,82.7 120.5,78.6 120.5,78.6 C119.2,72.0 123.4,76.3 123.4,76.3 C127.3,80.9 125.5,87.3 125.5,87.3 C122.9,97.6 130.6,101.9 134.4,103.2"
          fill="currentColor"
          style="transform-origin: 130px 106px"
          class="octo-arm"
        ></path>
        <path
          d="M115.0,115.0 C114.9,115.1 118.7,116.5 119.8,115.4 L133.7,101.6 C136.9,99.2 139.9,98.4 142.2,98.6 C133.8,88.0 127.5,74.4 143.8,58.0 C148.5,53.4 154.0,51.2 159.7,51.0 C160.3,49.4 163.2,43.6 171.4,40.1 C171.4,40.1 176.1,42.5 178.8,56.2 C183.1,58.6 187.2,61.8 190.9,65.4 C194.5,69.0 197.7,73.2 200.1,77.6 C213.8,80.2 216.3,84.9 216.3,84.9 C212.7,93.1 206.9,96.0 205.4,96.6 C205.1,102.4 203.0,107.8 198.3,112.5 C181.9,128.9 168.3,122.5 157.7,114.1 C157.9,116.9 156.7,120.9 152.7,124.9 L141.0,136.5 C139.8,137.7 141.6,141.9 141.8,141.8 Z"
          fill="currentColor"
          class="octo-body"
        ></path></svg></a
    ><style>
      .github-corner:hover .octo-arm {
        animation: octocat-wave 560ms ease-in-out;
      }
      @keyframes octocat-wave {
        0%,
        100% {
          transform: rotate(0);
        }
        20%,
        60% {
          transform: rotate(-25deg);
        }
        40%,
        80% {
          transform: rotate(10deg);
        }
      }
      @media (max-width: 500px) {
        .github-corner:hover .octo-arm {
          animation: none;
        }
        .github-corner .octo-arm {
          animation: octocat-wave 560ms ease-in-out;
        }
      }
    </style>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script
      src="https://code.jquery.com/jquery-3.3.1.min.js"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"
      integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"
      integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy"
      crossorigin="anonymous"
    ></script>

    <!-- datepicker -->
    <script src="https://cdn.jsdelivr.net/npm/@chenfengyuan/datepicker@1.0.9/dist/datepicker.min.js"></script>

    <!-- YASGUI stuff -->
    <script src="https://cdn.jsdelivr.net/npm/yasgui-yasr@2.12.19/dist/yasr.bundled.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/yasgui-yasqe@2.11.22/dist/yasqe.bundled.min.js"></script>

    <script>
      var config = {
        "@context": {
          Ontology: "http://www.w3.org/2002/07/owl#Ontology",
          Class: "http://www.w3.org/2002/07/owl#Class",
          ObjectProperty: "http://www.w3.org/2002/07/owl#ObjectProperty",
          label: "http://www.w3.org/2000/01/rdf-schema#label",
          domain: {
            "@id": "http://www.w3.org/2000/01/rdf-schema#domain",
            "@type": "@id",
          },
          range: {
            "@id": "http://www.w3.org/2000/01/rdf-schema#range",
            "@type": "@id",
          },
          unionOf: {
            "@id": "http://www.w3.org/2002/07/owl#unionOf",
            "@type": "@id",
          },
          subPropertyOf: {
            "@id": "http://www.w3.org/2000/01/rdf-schema#subPropertyOf",
            "@type": "@id",
          },
          faIcon:
            "http://data.sparna.fr/ontologies/sparnatural-config-core#faIcon",
          sparqlString:
            "http://data.sparna.fr/ontologies/sparnatural-config-core#equivalentPath",
          sparnatural:
            "http://data.sparna.fr/ontologies/sparnatural-config-core#",
          datasources:
            "http://data.sparna.fr/ontologies/sparnatural-config-datasources#",
        },
        "@graph": [
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto",
            "@type": "Ontology",
          },
          {
            "@id": "http://dbpedia.org/ontology/Museum",
            "@type": "Class",
            label: [
              { "@value": "Museum", "@language": "en" },
              { "@value": "Musée", "@language": "fr" },
            ],
            faIcon: "fas fa-university",
          },
          {
            "@id": "http://dbpedia.org/ontology/Country",
            "@type": "Class",
            label: [
              { "@value": "Country", "@language": "en" },
              { "@value": "Pays", "@language": "fr" },
            ],
            faIcon: "fas fa-globe-africa",
          },
          {
            "@id": "http://dbpedia.org/ontology/Artwork",
            "@type": "Class",
            label: [
              { "@value": "Artwork", "@language": "en" },
              { "@value": "Oeuvre", "@language": "fr" },
            ],
            faIcon: "fas fa-paint-brush",
          },
          {
            "@id": "http://dbpedia.org/ontology/Person",
            "@type": "Class",
            label: [
              { "@value": "Person", "@language": "en" },
              { "@value": "Personne", "@language": "fr" },
            ],
            faIcon: "fas fa-male",
          },
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Search",
            "@type": "Class",
            label: [
              { "@value": "Search", "@language": "en" },
              { "@value": "Rechercher", "@language": "fr" },
            ],
            faIcon: "fas fa-search",
          },
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Date",
            "@type": "Class",
            label: [
              { "@value": "Date", "@language": "en" },
              { "@value": "Date", "@language": "fr" },
            ],
            faIcon: "fas fa-calendar-alt",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Movement",
            "@type": "Class",
            subClassOf: "sparnatural:LinkedDataClass",
            label: [
              { "@value": "Movement", "@language": "en" },
              { "@value": "Mouvement", "@language": "fr" },
            ],
            faIcon: "fas fa-palette",
            sparqlString: "<http://www.w3.org/2004/02/skos/core#Concept>",
          },
          {
            "@id": "http://dbpedia.org/ontology/country",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:ListProperty",
            label: [
              { "@value": "country", "@language": "en" },
              { "@value": "pays", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Museum",
            range: "http://dbpedia.org/ontology/Country",
            datasource: "datasources:list_rdfslabel_count",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#countryOf",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "country of", "@language": "en" },
              { "@value": "lieu de", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Country",
            range: "http://dbpedia.org/ontology/Museum",
            sparqlString: "^<http://dbpedia.org/ontology/country>",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id": "http://dbpedia.org/ontology/museum",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "displayed at", "@language": "en" },
              { "@value": "exposée à", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Artwork",
            range: "http://dbpedia.org/ontology/Museum",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#displays",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:NonSelectableProperty",
            label: [
              { "@value": "displays", "@language": "en" },
              { "@value": "expose", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Museum",
            range: "http://dbpedia.org/ontology/Artwork",
            sparqlString: "^<http://dbpedia.org/ontology/museum>",
          },
          {
            "@id": "http://dbpedia.org/ontology/author",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "author", "@language": "en" },
              { "@value": "auteur", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Artwork",
            range: "http://dbpedia.org/ontology/Person",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#created",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "created", "@language": "en" },
              { "@value": "a créé", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range: "http://dbpedia.org/ontology/Artwork",
            sparqlString: "^<http://dbpedia.org/ontology/author>",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#bornIn",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:ListProperty",
            label: [
              { "@value": "born in", "@language": "en" },
              { "@value": "né à", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range: "http://dbpedia.org/ontology/Country",
            sparqlString:
              "<http://dbpedia.org/ontology/birthPlace>/<http://dbpedia.org/ontology/country>",
            datasource: "datasources:list_rdfslabel_alpha",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#birthPlace",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "birth place", "@language": "en" },
              { "@value": "lieu de naissance", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Country",
            range: "http://dbpedia.org/ontology/Person",
            sparqlString:
              "^(<http://dbpedia.org/ontology/birthPlace>/<http://dbpedia.org/ontology/country>)",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#diedIn",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:ListProperty",
            label: [
              { "@value": "died at", "@language": "en" },
              { "@value": "mort à", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range: "http://dbpedia.org/ontology/Country",
            sparqlString:
              "<http://dbpedia.org/ontology/deathPlace>/<http://dbpedia.org/ontology/country>",
            datasource: "datasources:list_rdfslabel_alpha",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#deathPlace",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "death place", "@language": "en" },
              { "@value": "lieu de décès", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Country",
            range: "http://dbpedia.org/ontology/Person",
            sparqlString:
              "^(<http://dbpedia.org/ontology/deathPlace>/<http://dbpedia.org/ontology/country>)",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id": "http://dbpedia.org/ontology/deathDate",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:TimeProperty-Year",
            label: [
              { "@value": "death date", "@language": "en" },
              { "@value": "date de décès", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range: "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Date",
          },
          {
            "@id": "http://dbpedia.org/ontology/birthDate",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:TimeProperty-Date",
            label: [
              { "@value": "birth date", "@language": "en" },
              { "@value": "date de naissance", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range: "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Date",
          },
          {
            "@id": "http://dbpedia.org/ontology/movement",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:ListProperty",
            label: [
              { "@value": "movement", "@language": "en" },
              { "@value": "mouvement", "@language": "fr" },
            ],
            domain: "http://dbpedia.org/ontology/Person",
            range:
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Movement",
            datasource: "datasources:list_rdfslabel_count",
          },
          {
            "@id":
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#movementIncludes",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:AutocompleteProperty",
            label: [
              { "@value": "participant", "@language": "en" },
              { "@value": "participant", "@language": "fr" },
            ],
            domain:
              "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Movement",
            range: "http://dbpedia.org/ontology/Person",
            sparqlString: "^<http://dbpedia.org/ontology/movement>",
            datasource: "datasources:search_rdfslabel_bifcontains",
          },
          {
            "@id": "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#search",
            "@type": "ObjectProperty",
            subPropertyOf: "sparnatural:SearchProperty",
            label: [
              { "@value": "text search", "@language": "en" },
              { "@value": "recherche plein-texte", "@language": "fr" },
            ],
            domain: {
              "@type": "Class",
              unionOf: {
                "@list": [
                  { "@id": "http://dbpedia.org/ontology/Museum" },
                  { "@id": "http://dbpedia.org/ontology/Person" },
                  { "@id": "http://dbpedia.org/ontology/Artwork" },
                ],
              },
            },
            range: "http://labs.sparna.fr/sparnatural-demo-dbpedia/onto#Search",
          },
        ],
      };
    </script>

    <script>
      $.urlParam = function (name) {
        var results = new RegExp("[\\?&amp;]" + name + "=([^&amp;#]*)").exec(
          window.location.href
        );
        if (results == null) {
          return null;
        }
        return results[1] || 0;
      };
      var lang = $.urlParam("lang") != null ? $.urlParam("lang") : "fr";

      var sparnatural;
      $(document).ready(function ($) {
        sparnatural = $("#ui-search").Sparnatural({
          config: config,
          language: lang,
          maxDepth: 4,
          addDistinct: true,
          sendQueryOnFirstClassSelected: true,
          backgroundBaseColor: "2,184,117",
          autocomplete: null,
          list: null,
          defaultEndpoint: $("#endpoint").text(),
          onQueryUpdated: function (queryString, queryJson) {
            queryString = semanticPostProcess(queryString, queryJson);
            queryString = rdfsLabelPostProcess(queryString, queryJson);
            queryString = isPrimaryTopicOfPostProcess(queryString, queryJson);
            queryString = orderByPostProcess(queryString, queryJson);
            $("#sparql code").html(
              queryString
                .replace(/&/g, "&amp;")
                .replace(/</g, "&lt;")
                .replace(/>/g, "&gt;")
            );
            yasqe.setValue(queryString);
            yasqe.query();
          },
        });
      });

      prefixesPostProcess = function (queryString, queryJson) {
        if (queryString.indexOf("rdf-schema#") == -1) {
          queryString = queryString.replace(
            "SELECT ",
            "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> \nSELECT "
          );
        }
        return queryString;
      };

      isPrimaryTopicOfPostProcess = function (queryString, queryJson) {
        queryString = queryString.replace(
          new RegExp("}$"),
          "  ?this <http://xmlns.com/foaf/0.1/isPrimaryTopicOf> ?wikipedia \n}"
        );
        return queryString;
      };

      rdfsLabelPostProcess = function (queryString, queryJson) {
        queryString = queryString.replace(
          new RegExp("}$"),
          "  ?this rdfs:label ?label FILTER(lang(?label) = 'fr') \n}"
        );
        return queryString;
      };

      orderByPostProcess = function (queryString, queryJson) {
        queryString = queryString.replace(
          new RegExp("}$"),
          "}\nORDER BY ?label LIMIT 5000"
        );
        queryString = queryString.replace(
          "SELECT DISTINCT ?this",
          "SELECT DISTINCT (STR(?label) AS ?nom) ?wikipedia ?this"
        );
        return queryString;
      };

      semanticPostProcess = function (queryString, queryJson) {
        queryString = prefixesPostProcess(queryString, queryJson);
        queryString = sparnatural.expandSparql(queryString);
        return queryString;
      };

      var yasqe = YASQE.fromTextArea(document.getElementById("yasqe"), {
        sparql: {
          showQueryButton: true,
          endpoint: $("#endpoint").text(),
        },
      });

      var yasr = YASR(document.getElementById("yasr"), {
        //this way, the URLs in the results are prettified using the defined prefixes in the query
        getUsedPrefixes: yasqe.getPrefixesFromQuery,
        drawOutputSelector: false,
        drawDownloadIcon: false,
        // avoid persistency side-effects
        persistency: { prefix: false, results: { key: false } },
      });

      // link yasqe and yasr
      yasqe.options.sparql.callbacks.complete = yasr.setResponse;
    </script>
    <script type="text/javascript" src="./sparnatural.js"></script>
  </body>
</html>
